""" Main tuning script for resonator-2DQD devices """
""" Left DQD: DQD1"""

 #%% 1D scan with Keithley: current vs voltage

scanjob = {'sweepdata': {'param':'RP1', 'start':-200, 'end':0, 'step':0.5,'wait_time':0.1},
           'minstrument':['keithley1','keithley2'],'wait_time_startscan':3}
dataset=qtt.scans.scan1D(station, scanjob, plotparam='keithley1_amplitude')
ph=MatPlot(dataset.keithley1_amplitude)
addPPT(plt.gcf().number)

#plt.plot(dataset.Vsd1,dataset.keithley1_amplitude)
#plt.plot(dataset.T1,dataset.keithley1_amplitude)

#gates.resetgates(gv,gv)

"""Save before running!!!!!"""
savescript1()

#   qtt.pgeometry.tilefigs([ph.fig], [2,2])

 #%% 2D scan with Keithley: current vs voltage

scanjob = {'sweepdata': {'param':'RP1', 'start':200, 'end':00, 'step':1, 'wait_time':0.05},
           'stepdata': {'param':'T1', 'start':100, 'end':00, 'step':1, 'wait_time':0.05},
           'minstrument':['keithley1','keithley2'],'wait_time_startscan':3}
dataset=qtt.scans.scan2D(station, scanjob, plotparam='keithley1_amplitude')
ph=MatPlot(dataset.keithley1_amplitude)
addPPT(plt.gcf().number)

gates.resetgates(gv,gv)

"""Save before running!!!!!"""
savescript1()


 #%% 1D scan with ATS: S21 vs voltage

#global Buffer
#Buffer = np.zeros(2000000)

acquisition_controller.update_acquisitionkwargs(
                 samples_per_record=1000000,
                 records_per_buffer=1,
                 buffers_per_acquisition=1)

#change_resfreq_in_B(triton.Bz())
RF.power.set(-40)

LP1=-465
RP1=-200
gates.LP1(LP1)
gates.RP1(RP1)
span=50

for k in np.arange(10):
    #awg1.load_awg_file(r'C:\Users\OEM\Desktop\AWG Waveforms\fast_scan.awg')
    awg1.ch4_state(1)
    awg1.start()
    scanjob = {'sweepdata': {'param':'RP1', 'start':RP1-span/2, 'end':RP1+span/2, 'step':0.5,'wait_time':0.05},
               'minstrument':['acquisition_controller'],'wait_time_startscan':5}
    dataset=qtt.scans.scan1Dresonator( station, scanjob, datafunction=acquisition_controller.acquisition, rescal=rescal, plotparam='S21mag')
    ph1=MatPlot(dataset.default_parameter_array('S21mag'))
    addPPT(plt.gcf().number)
    #    ph2=MatPlot(dataset.default_parameter_array('S21phase'))
    #    addPPT(plt.gcf().number)

awg1.stop_all()
awg2.stop_all()
#gates.resetgates(gv,gv)

"""Save before running!!!!!"""
savescript1()

# volt1D


 #%% 1D scan with ATS: S21 vs voltage in the presence of pulsing

change_resfreq_in_B(triton.Bz())

det = gate_to_awg(15)
unloadRP = gate_to_awg(0)
unloadLP = gate_to_awg(0)
generate_pulsescheme_loading_compensation(2e-3,1000e-6,100e-6,100e-6,1e-6,[unloadRP,unloadLP],[det,-det])
#(t_total,t01,t_11, marker_delay, detuning[RP,LP], unloadposition[RP,LP])

acquisition_controller.update_acquisitionkwargs(
                 samples_per_record=8192,
                 records_per_buffer=200,
                 buffers_per_acquisition=1)

RF.power.set(-40)

#LP=-252.8
#RP=-62
#gates.LP(LP)
#gates.RP(RP)
span=25

#awg1.ch1_state(1)
#awg1.ch2_state(1)
#awg1.start()
scanjob = {'sweepdata': {'param':'RP', 'start':RP-span/2, 'end':RP+span/2, 'step':0.2,'wait_time':0.05},
           'minstrument':['acquisition_controller'],'wait_time_startscan':5}
dataset=qtt.scans.scan1Dresonator( station, scanjob, datafunction=acquisition_controller.acquisition, rescal=rescal, plotparam='S21mag')
ph1=MatPlot(dataset.default_parameter_array('S21mag'))
ph2=MatPlot(dataset.default_parameter_array('S21phase'))

awg1.stop_all()
awg2.stop_all()
gates.RP(RP)

"""Save before running!!!!!"""
savescript1()


#%% 2D scan with ATS and Keithley: voltage vs voltage vs S21 and current +++++++++++ the keithleys are hardcoded... +++++++++++

acquisition_controller.update_acquisitionkwargs(
                 samples_per_record=1000000,
                 records_per_buffer=1,
                 buffers_per_acquisition=1)
period = 2e-3

f_RF_offset = 80e6
change_probe_freq(f, f_RF_offset, demodulation_tf=False)
rf_power = -40

prepare_awg1_awg2_seq_sync(f_start=f, f_RF_offset=f_RF_offset, period=period, rf_power=rf_power)


scanjob = {
           'sweepdata': {'param':'RP1', 'start':-700, 'end':-600, 'step':2, 'wait_time':0.005},
           'stepdata': {'param':'LP1', 'start':-650, 'end':-550, 'step':2, 'wait_time':0.005},
           'minstrument':['acquisition_controller','keithley1','keithley2'],'wait_time_startscan':5}
dataset=qtt.scans.scan2Dresonator(station, scanjob, datafunction=acquisition_controller.acquisition, rescal=rescal, plotparam='S21mag')
ph1=MatPlot(dataset.S21mag)
addPPT(plt.gcf().number)
ph2=MatPlot(dataset.S21phase)
addPPT(plt.gcf().number)
ph3=MatPlot(dataset.keithley1_amplitude)
addPPT(plt.gcf().number)

awg1.stop_all()
awg2.stop_all()
#gates.resetgates(gv,gv)

"""Save before running!!!!!"""
savescript1()

#2sss1

#%% FAST 2D scan with ATS and awg: AWG voltage vs DAC voltage vs S21  ++++++++++++++++++++++++++++++++++++++++++++++++++++

#change_resfreq_in_B(triton.Bz())

#ats_inst.config(decimation=2)

period = 4e-3
step_pts = 50
sweep_pts = 100
n_samples = round(period*ats_inst.get_sample_rate())
acquisition_controller_fast.update_acquisitionkwargs(
                 samples_per_record=n_samples,
                 records_per_buffer=10,
                 buffers_per_acquisition=10)

span = 50             # max span = 652 for 4.5Vpp and 23db att.
LP1 = -605
RP1 = -641
gates.LP1(LP1+span/2)   # to account for RC delay at the start
gates.RP1(RP1)

f_RF_offset = 60e6
rf_power = -40
sweep_item1 = AwgChannelScanItem(awg_name='awg1', ch_name='ch1', wf_type='sawtooth_fast', amplitude=gate_to_awg(1,span))
prepare_awg1_awg2_seq_sync(f_start=f, f_RF_offset=f_RF_offset, period=period, rf_power=rf_power, 
                           acq_ctrl=acquisition_controller_fast,
                           item1=sweep_item1)

scanjob = {'sweepdata': {'param':'RP1', 'start':RP1-span/2, 'end':RP1+span/2, 'step':span/sweep_pts, 'wait_time':1e-6},
           'stepdata': {'param':'LP1', 'start':LP1+span/2, 'end':LP1-span/2, 'step':span/step_pts, 'wait_time':50e-3},
           'minstrument':['acquisition_controller_fast'],'wait_time_startscan':5}
dataset=qtt.scans.scan2Dresonatorfast(station, scanjob, datafunction=acquisition_controller_fast.acquisition, rescal=rescal, plotparam='S21mag')
ph1=MatPlot(dataset.S21mag)
addPPT(plt.gcf().number)
ph2=MatPlot(dataset.S21phase)
addPPT(plt.gcf().number)

awg1.stop_all()
awg2.stop_all()
#gates.resetgates(gv,gv)

"""Save before running!!!!!"""
savescript1()
#2fff

#%% TURBO 2D scan with ATS and awg: awg voltage vs awg voltage vs S21  ++++++++++++++++++++++++++++++++++++++++++++++++++++
"""
change_resfreq_in_B(triton.Bz())

acquisition_controller_fast.update_acquisitionkwargs(
                 samples_per_record=2000000,
                 records_per_buffer=15,
                 buffers_per_acquisition=50)

RF.power.set(-40)
span = 40
step = span/100        # 100 pixels in LP and RP, for IF=5MHz this corresponds to 1 wave period/pixel
LP= -272.4
RP= -40.4
gates.RP(RP)
gates.LP(LP)
#awg1.load_awg_file(r'C:\Users\OEM\Desktop\AWG Waveforms\fast_scan.awg')
awg1.ch1_waveform('Sawtooth_50kHz_10MSs_20kpoints')
awg1.ch1_amp(gate_to_awg(span))
awg1.ch2_amp(gate_to_awg(span))
awg1.ch1_state(1)
awg1.ch2_state(1)
awg1.start()

scanjob = {'sweepdata': {'param':'RP', 'start':RP-span/2, 'end':RP+span/2, 'step':step, 'wait_time':0.00001},
           'stepdata': {'param':'LP', 'start':LP-span/2, 'end':LP+span/2, 'step':step, 'wait_time':0.00001},
           'minstrument':['acquisition_controller_fast'],'wait_time_startscan':5}
dataset=qtt.scans.scan2Dresonatorturbo(station, scanjob, datafunction=acquisition_controller_fast.acquisition, rescal=rescal, plotparam='S21mag')
ph1=MatPlot(dataset.S21mag)
addPPT(plt.gcf().number)
ph2=MatPlot(dataset.S21phase)
addPPT(plt.gcf().number)


awg1.stop_all()
awg2.stop_all()
awg1.ch1_waveform('Sawtooth_500Hz_10MSs_20kpoints')


#Save before running!!!!!
savescript1()

#2ttt
"""

#%% TURBO 2D scan with ATS and awg: AWG voltage vs RF frequency vs S21  ++++++++++++++++++++++++++++++++++++++++++++++++++++

#change_resfreq_in_B(triton.Bz())
#triton.magnet_sweeprate.set(0.05)
#triton.Bz(0.071) 
#ats_inst.config(decimation=2)

period = 4e-3
step_pts = 100
sweep_pts = 100
n_samples = round(period*ats_inst.get_sample_rate())
acquisition_controller_fast.update_acquisitionkwargs(
                 samples_per_record=n_samples,
                 records_per_buffer=10,
                 buffers_per_acquisition=100 )

span = 14
spanf = 20e6

#(de)tune dot2
#gates.RP2(RP2-30)

#LP1 = -600
RP1 = -644
gates.RP1(RP1)
#gates.LP1(LP1)

f_center = 6.910e9
f_RF_offset = 60e6
rf_power = -47.5
sweep_item1 = AwgChannelScanItem(awg_name='awg1', ch_name='ch1', wf_type='sawtooth_turbo', amplitude=gate_to_awg(1,span))
prepare_awg1_awg2_seq_sync(f_start=f_center-spanf/2, df=spanf, f_RF_offset=f_RF_offset, period=period, rf_power=rf_power, 
                           n_step_points = step_pts, 
                           acq_ctrl=acquisition_controller_fast,
                           item1=sweep_item1)

rf_lo_offset = 0e6
offset_probe_freq(-rf_lo_offset)

scanjob = {'sweepdata': {'param':'RP1', 'start':RP1-span/2, 'end':RP1+span/2, 'step':span/sweep_pts, 'wait_time':1e-6},
           'stepdata': {'param':'RF', 'start':(f_center - rf_lo_offset)-spanf/2, 'end':(f_center - rf_lo_offset)+spanf/2, 'step':spanf/step_pts, 'wait_time':1e-6},
           'minstrument':['acquisition_controller_fast'],'wait_time_startscan':3}

dataset = qtt.scans.scan2DresonatorturboRF(station, scanjob, datafunction=acquisition_controller_fast.acquisition, rescal=rescal, plotparam='S21mag')
ph1 = MatPlot(dataset.S21mag)
addPPT(plt.gcf().number)

offset_probe_freq(rf_lo_offset)

awg1.stop_all()
awg2.stop_all()

"""Save before running!!!!!"""
savescript1()
#rttt



# Fit for zero detuning
ds = dataset
ds.gate = ds.RP1
F_REF = 6.915e9
xdata = ds.gate.ndarray[1,:]
val, idx = find_closest(ds.frequency.ndarray, F_REF)
ydata = ds.S21mag.ndarray[idx,:]
popt, perr, doubletanh = fit_doubletanh(xdata, ydata)
x0 = np.mean(popt[3:5])
title = ds.metadata['scantime'][0:10] + '/' + os.path.split(ds.location)[1]
# Fano fit on center linecut
xdata2 = ds.frequency.ndarray
val, idx = find_closest(ds.gate.ndarray[1,:], x0)
ydata2 = ds.S21mag.ndarray[:,idx]
popt2, perr2, fano_peak = fit_fano(xdata2, ydata2, EXPONENT=1)
# Plot
plot_center_and_fano_fit(ds.gate.ndarray, ds.frequency.ndarray, ds.S21mag.ndarray, 
                         ds.gate.label, ds.frequency.label, ds.S21mag.label, title,
                         xdata, ydata, doubletanh, popt, F_REF, x0,
                         xdata2, ydata2, fano_peak, popt2)
plt.clim(0, 0.000035)
addPPT(plt.gcf().number)
print('x0 = {:.4g} mV, f0 = {:.5g} GHz, fwhm = {:.2g} MHz'.format(x0, popt2[0]/1e9, popt2[1]/1e6))

#%% TURBO 2D scan with ATS and awg: AWG voltage vs RF frequency vs S21, V.R.S. reconstruction ++++++++++++++++++++++++++++++++++++++++++++++++++++
acquisition_controller_fast.update_acquisitionkwargs(
                 samples_per_record=1000000,
                 records_per_buffer=10,
                 buffers_per_acquisition=500 )
period = 4e-3
step_pts = 100

span = 11
step = span/100       # 100 pixels in RP, for IF=10MHz this corresponds to 2 wave periods/pixel

#(de)tune dot2
#gates.RP2(RP2-30)

#LP1=-605
#RP1= -638
#RP2 =-778
gates.RP1(RP1)
gates.RP2(RP2)
spanf = 60e6
stepf = spanf/step_pts       # 100 pixels in frequency
f_center = 6.910e9


f_RF_offset = 50e6
rf_power = -47.5

sweep_item1 = AwgChannelScanItem(awg_name='awg1', ch_name='ch1', wf_type='sawtooth_turbo', amplitude=gate_to_awg(1,span))
sweep_item2 = AwgChannelScanItem(awg_name='awg1', ch_name='ch2', wf_type='sawtooth_turbo', amplitude=gate_to_awg(2,span))
b_fields = np.arange(58e-3, 48e-3, -0.1e-3)
#b_fields = [0.058]
for b_field in b_fields:
    triton.Br(b_field)
    
    # DQD2 turboscan to center

    #(de)tune dot 1
    gates.RP1(RP1-30)
    prepare_awg1_awg2_seq_sync(f_start=f_center-spanf/2, df=spanf, f_RF_offset=f_RF_offset, period=period, 
                               rf_power=rf_power, n_step_points = step_pts, 
                               item1=sweep_item2)
    
    scanjob = {'sweepdata': {'param':'RP2', 'start':RP2-span/2, 'end':RP2+span/2, 'step':step, 'wait_time':0.00001},
           'stepdata': {'param':'RF', 'start':f_center-spanf/2, 'end':f_center+spanf/2, 'step':stepf, 'wait_time':0.00001},
           'minstrument':['acquisition_controller_fast'],'wait_time_startscan':3}
    dataset=qtt.scans.scan2DresonatorturboRF(station, scanjob, datafunction=acquisition_controller_fast.acquisition, rescal=rescal, plotparam='S21mag',clip_first_point=True)
#    ph1=MatPlot(dataset.S21mag)
#    addPPT(plt.gcf().number)
    
    # Fit for center
    F_REF = 6.915e9
    xdata = dataset.RP2.ndarray[1,:]
    val, idx = find_closest(dataset.frequency.ndarray, F_REF)
    ydata = dataset.S21mag.ndarray[idx,:]
    popt, perr, doubletanh = fit_doubletanh(xdata, ydata)
    x0 = np.mean(popt[3:5])
    plot_center_fit(dataset.RP2.ndarray, dataset.frequency.ndarray, dataset.S21mag.ndarray, 
                    dataset.RP2.label, dataset.frequency.label, dataset.S21mag.label, os.path.split(dataset.location)[1],
                    xdata, ydata, doubletanh, popt, F_REF, x0)
    addPPT(plt.gcf().number)
    #center dot 2
    gates.RP1(RP1)
    if (-850 <= x0) & (x0 <= -700):
        gates.RP2(x0)
        RP2 = gates.RP2()
    else:
        print('x0 outside of bounds, breaking loop')
        break
    awg1.stop_all()
    awg2.stop_all()
    #Simultaneous
    prepare_awg1_awg2_seq_sync(f_start=f_center-spanf/2, df=spanf, f_RF_offset=f_RF_offset, period=period, 
                               rf_power=rf_power, n_step_points = step_pts, 
                               item1=sweep_item1)
    #awg2.ch1_state(0)
    
    rf_lo_offset = 8e6
    RF_frequency = RF.frequency()
    LO_frequency = LO.frequency()
    RF.frequency(RF_frequency-rf_lo_offset)
    LO.frequency(LO_frequency-rf_lo_offset)
    
    scanjob = {'sweepdata': {'param':'RP1', 'start':RP1-span/2, 'end':RP1+span/2, 'step':step, 'wait_time':0.00001},
               'stepdata': {'param':'RF', 'start':(f_center - rf_lo_offset)-spanf/2, 'end':(f_center - rf_lo_offset)+spanf/2, 'step':stepf, 'wait_time':0.00001},
               'minstrument':['acquisition_controller_fast'],'wait_time_startscan':3}
        
    dataset=qtt.scans.scan2DresonatorturboRF(station, scanjob, datafunction=acquisition_controller_fast.acquisition, rescal=rescal, plotparam='S21mag',clip_first_point=True)
    ph1=MatPlot(dataset.S21mag, clim=(0, 0.00015))
    addPPT(plt.gcf().number)
    
     
    RF_frequency = RF.frequency()
    LO_frequency = LO.frequency()
    RF.frequency(RF_frequency+rf_lo_offset)
    LO.frequency(LO_frequency+rf_lo_offset)
    awg1.stop_all()
    awg2.stop_all()
    #(de)tune dot 2
    gates.RP2(RP2-30)
        
    #DQD1
    prepare_awg1_awg2_seq_sync(f_start=f_center-spanf/2, df=spanf, f_RF_offset=f_RF_offset, period=period, 
                               rf_power=rf_power, n_step_points = step_pts, 
                               item1=sweep_item1)
    #awg2.ch1_state(0)
    
    rf_lo_offset = 0
    RF_frequency = RF.frequency()
    LO_frequency = LO.frequency()
    RF.frequency(RF_frequency-rf_lo_offset)
    LO.frequency(LO_frequency-rf_lo_offset)
    
    scanjob = {'sweepdata': {'param':'RP1', 'start':RP1-span/2, 'end':RP1+span/2, 'step':step, 'wait_time':0.00001},
               'stepdata': {'param':'RF', 'start':(f_center - rf_lo_offset)-spanf/2, 'end':(f_center - rf_lo_offset)+spanf/2, 'step':stepf, 'wait_time':0.00001},
               'minstrument':['acquisition_controller_fast'],'wait_time_startscan':3}
        
    dataset=qtt.scans.scan2DresonatorturboRF(station, scanjob, datafunction=acquisition_controller_fast.acquisition, rescal=rescal, plotparam='S21mag',clip_first_point=True)
    ph1=MatPlot(dataset.S21mag, clim=(0, 0.00015))
#    addPPT(plt.gcf().number)
#    
    # Fit for center
    F_REF = 6.915e9
    xdata = dataset.RP1.ndarray[1,:]
    val, idx = find_closest(dataset.frequency.ndarray, F_REF)
    ydata = dataset.S21mag.ndarray[idx,:]
    popt, perr, doubletanh = fit_doubletanh(xdata, ydata)
    x0 = np.mean(popt[3:5])
    plot_center_fit(dataset.RP1.ndarray, dataset.frequency.ndarray, dataset.S21mag.ndarray, 
                    dataset.RP1.label, dataset.frequency.label, dataset.S21mag.label, os.path.split(dataset.location)[1],
                    xdata, ydata, doubletanh, popt, F_REF, x0)
    addPPT(plt.gcf().number)
    #center dot 1
    gates.RP2(RP2)
    if (-700 <= x0) & (x0 <= -550):
        gates.RP1(x0)
        RP1 = gates.RP1()
    else:
        print('x0 outside of bounds, breaking loop')
        break
            
    
    RF_frequency = RF.frequency()
    LO_frequency = LO.frequency()
    RF.frequency(RF_frequency+rf_lo_offset)
    LO.frequency(LO_frequency+rf_lo_offset)
    awg1.stop_all()
    awg2.stop_all()
    plt.close('all')


"""Save before running!!!!!"""
savescript1()
#rtbscan




#%% TURBO 2D scan with ATS and awg: AWG voltage vs RF frequency vs S21  ++++++++++++++++++++++++++++++++++++++++++++++++++++

#change_resfreq_in_B(triton.Bz())
#triton.magnet_sweeprate.set(0.05)
#triton.Bz(0.071) 
acquisition_controller_fast.update_acquisitionkwargs(
                 samples_per_record=1000000,
                 records_per_buffer=10,
                 buffers_per_acquisition=500)

#RF.power.set(13)
span = 14
step = span/100        # 100 pixels in RP, for IF=10MHz this corresponds to 2 wave periods/pixel

#(de)tune dot2
#gates.RP2(RP2-30)

#LP1=-605
RP1=-643
gates.RP1(RP1)
#gates.LP1(LP1)
spanf =20e6
stepf = spanf/100       # 100 pixels in frequency
f_center = 6.910e9
F_REF = 6.915e9

make_RF_chirp(f_start=f_center-spanf/2, df=spanf, f_RF_offset=60e6, period=2e-3, rf_power=-50)
#awg1.ch1_waveform('Sawtooth_50kHz_10MSs_20kpoints')
#awg1.ch1_amp(gate_to_awg(span))
#awg1.ch1_state(1)


awg1.ch1_waveform('sawtoothturbo')
awg1.ch1_amp(gate_to_awg(1,span))
awg1.ch1_state(1)
awg1.ch3_waveform('chirpRF')
awg1.ch3_state(1)
awg1.ch4_waveform('chirpLO')
awg1.ch4_state(1)
awg1.start()

rf_lo_offset = 0
RF_frequency = RF.frequency()
LO_frequency = LO.frequency()
RF.frequency(RF_frequency-rf_lo_offset)
LO.frequency(LO_frequency-rf_lo_offset)

scanjob = {'sweepdata': {'param':'RP1', 'start':RP1-span/2, 'end':RP1+span/2, 'step':step, 'wait_time':0.00001},
           'stepdata': {'param':'RF', 'start':(f_center - rf_lo_offset)-spanf/2, 'end':(f_center - rf_lo_offset)+spanf/2, 'step':stepf, 'wait_time':0.00001},
           'minstrument':['acquisition_controller_fast'],'wait_time_startscan':3}
    
dataset = qtt.scans.scan2DresonatorturboRF(station, scanjob, datafunction=acquisition_controller_fast.acquisition, rescal=rescal, plotparam='S21mag',clip_first_point=True)
ds = dataset
ph1 = MatPlot(ds.S21mag)
#addPPT(plt.gcf().number)


# Fit for zero detuning
xdata = ds.RP1.ndarray[1,:]
val, idx = find_closest(ds.frequency.ndarray, F_REF)
ydata = ds.S21mag.ndarray[idx,:]
popt, perr, doubletanh = fit_doubletanh(xdata, ydata)
x0 = np.mean(popt[3:5])
title = ds.metadata['scantime'][0:10] + '/' + os.path.split(ds.location)[1]
plot_center_fit(ds.RP1.ndarray, ds.frequency.ndarray, ds.S21mag.ndarray, 
                ds.RP1.label, ds.frequency.label, ds.S21mag.label, title,
                xdata, ydata, doubletanh, popt, F_REF, x0)
addPPT(plt.gcf().number)

# Fano fit on center linecut
xdata = ds.frequency.ndarray
val, idx = find_closest(ds.RP1.ndarray[1,:], x0)
ydata = ds.S21mag.ndarray[:,idx]
popt, perr, fano_peak = fit_fano(xdata, ydata, EXPONENT=1)
plot_fano_fit(xdata, ydata, 
              ds.frequency.label, ds.S21mag.label, title,
              fano_peak, popt)
addPPT(plt.gcf().number)
print('x0 =', x0, 'mV, f0 =', popt[0]/1e9, 'GHz, fwhm =', popt[1]/1e6, 'MHz')



RF_frequency = RF.frequency()
LO_frequency = LO.frequency()
RF.frequency(RF_frequency+rf_lo_offset)
LO.frequency(LO_frequency+rf_lo_offset)
awg1.stop_all()
awg2.stop_all()


"""Save before running!!!!!"""
savescript1()
#rtttspinreadout

#%% RF 2D scan with ATS: voltage vs RF frequency vs S21

acquisition_controller.update_acquisitionkwargs(
                 samples_per_record=2000000,
                 records_per_buffer=1,
                 buffers_per_acquisition=1)

RF.power.set(-40)

gates.LP1(-449)
RP1 = -422
span = 15

awg1.ch4_state(1)
awg1.start()
scanjob = {'sweepdata': {'param':'RF.frequency', 'start':f-10e6, 'end':f+10e6, 'step':0.2e6,'wait_time':0.00001},
           'stepdata': {'param':'RP1', 'start':RP1-span/2, 'end':RP1+span/2, 'step':1, 'wait_time':0.005},
           'minstrument':['acquisition_controller'],'wait_time_ startscan':3}
dataset=qtt.scans.RFscan2D(station, scanjob, datafunction=acquisition_controller.acquisition, rescal=rescal, plotparam='S21mag')
ph = MatPlot(dataset.S21mag)
addPPT(plt.gcf().number)

scanjob = {'sweepdata': {'param':'RF.frequency', 'start':f-10e6, 'end':f+10e6, 'step':0.2e6,'wait_time':0.00001},
           'stepdata': {'param':'RP1', 'start':RP1+span/2, 'end':RP1-span/2, 'step':1, 'wait_time':0.005},
           'minstrument':['acquisition_controller'],'wait_time_ startscan':3}
dataset=qtt.scans.RFscan2D(station, scanjob, datafunction=acquisition_controller.acquisition, rescal=rescal, plotparam='S21mag')
ph = MatPlot(dataset.S21mag)
addPPT(plt.gcf().number)

# set the frequency back to resonance
RF.frequency.set(f)
LO.frequency.set(f + acquisition_controller.demodulation_frequency)

awg1.stop_all()
awg2.stop_all()
#gates.resetgates(gv,gv)

"""Save before running!!!!!"""
savescript1()

#rsss

#%% FAST RF 2D scan with ATS and awg: awg voltage vs RF frequency vs S21  ++++++++++++++++++++++++++++++++++++++++++++++++++++

acquisition_controller_fast.update_acquisitionkwargs(
                 samples_per_record=2000000,
                 records_per_buffer=10,
                 buffers_per_acquisition=10)

RF.power.set(-40)

""" Apply 2-tone """
#mw = mw1
#mw.power.set(-0)
#mw.frequency.set(1.96945e9)
#mw.on()

#LP1= -492
RP1= -650
gates.LP1(LP1)
gates.RP1(RP1)
span = 15
step = span/200         # 200 pixels in RP

awg1.ch1_amp(gate_to_awg(1,span))
awg1.ch1_state(1)
awg1.start()
scanjob = {'sweepdata': {'param':'RP1', 'start':RP1-span/2, 'end':RP1+span/2, 'step':step, 'wait_time':0.00001},
           'stepdata': {'param':'RF.frequency', 'start':f-14e6, 'end':f+5e6, 'step':0.2e6, 'wait_time':0.00001},
           'minstrument':['acquisition_controller_fast'],'wait_time_startscan':5}
dataset=qtt.scans.RFscan2Dfast(station, scanjob, datafunction=acquisition_controller_fast.acquisition, rescal=rescal, plotparam='S21mag')
ph=MatPlot(dataset.S21mag)
addPPT(plt.gcf().number)

# set the frequency back to resonance    
change_probe_freq(f)

awg1.stop_all()
awg2.stop_all()
#mw1.off()
#mw1.frequency.set(1e6)
#gates.resetgates(gv,gv)

"""Save before running!!!!!"""
savescript1()

#rfff


#%%

def getvals(fig=6, g1='LP', g2='RP', gates):
    """ Docs
    
    Automatically get g1 and g2?
    """
    plt.figure(6)
    x=qtt.pgeometry.ginput(1, '.m')
    #qtt.pgeometry.
    print('got %s' % x)
    gates.set(g2, x[0])
    gates.set(g1, x[1])
    return x
    
x=getvals(fig=6)    

#bbb

#%% RF 2D scan with ATS: Bz-field vs dac voltage

acquisition_controller.update_acquisitionkwargs(
                 samples_per_record=8192,
                 records_per_buffer=20,
                 buffers_per_acquisition=10)

#awg1.load_awg_file(r'C:\Users\OEM\Desktop\AWG Waveforms\fast_scan.awg')

# set new (dispersively shifted) resonance frequency
#f1 = 6.0402e9
#RF.frequency.set(f1)
#LO.frequency.set(f1 + acquisition_controller.demodulation_frequency)

#triton.magnet_sweeprate.set(0.1)
#triton.Bz(0.01)
#triton.magnet_sweeprate.set(0.05)
#triton.Bz(-0.05)
#triton.Bz(0.04)
#triton.Bz(-0.03)
#triton.Bz(0.02)
#triton.Bz (-0.01)
#triton.Bz(0)

triton.magnet_sweeprate.set(0.01)
span = 12
#RP=-165.5

RF.power.set(-40)
awg1.ch4_state(1)
awg1.start()
scanjob = {'sweepdata': {'param':'RP', 'start':RP-span/2, 'end':RP+span/2, 'step':0.1,'wait_time':0.01},
           'stepdata': {'param':'Bz', 'start':0, 'end':2, 'step':0.01, 'wait_time':1},
           'minstrument':['acquisition_controller'],'wait_time_startscan':5}
dataset=qtt.scans.Bzscan2D(station, scanjob, datafunction=acquisition_controller.acquisition, rescal=rescal, plotparam='S21mag')
plt.set_cmap('viridis')
ph = MatPlot(dataset.S21mag)
addPPT(plt.gcf().number)

awg1.stop_all()
awg2.stop_all()
triton.magnet_sweeprate.set(0.1)
triton.Bz(0.01)
triton.magnet_sweeprate.set(0.05)
triton.Bz(-0.05)
triton.Bz(0.04)
triton.Bz(-0.03)
triton.Bz(0.02)
triton.Bz (-0.01)
triton.Bz(0)

det = gate_to_awg(1,-30)
unloadRP = gate_to_awg(1,-30)
unloadLP = gate_to_awg(1,-15)
generate_pulsescheme_loading_compensation(2000e-6,50e-6,10e-6,1000e-6,0e-6,[unloadRP,unloadLP],[det,-det])
RF.power.set(-40)
scanjob = {'sweepdata': {'param':'RP', 'start':RP-span/2, 'end':RP+span/2, 'step':0.1,'wait_time':0.01},
           'stepdata': {'param':'Bz', 'start':0, 'end':2, 'step':0.01, 'wait_time':1},
           'minstrument':['acquisition_controller'],'wait_time_startscan':5}
dataset=qtt.scans.Bzscan2D(station, scanjob, datafunction=acquisition_controller.acquisition, rescal=rescal, plotparam='S21mag')
ph = MatPlot(dataset.S21mag)
addPPT(plt.gcf().number)

awg1.stop_all()
awg2.stop_all()
triton.magnet_sweeprate.set(0.1)
triton.Bz(0.01)
triton.magnet_sweeprate.set(0.05)
triton.Bz(-0.05)
triton.Bz(0.04)
triton.Bz(-0.03)
triton.Bz(0.02)
triton.Bz (-0.01)
triton.Bz(0)

# set the frequency back to resonance    
#RF.frequency.set(f)
#LO.frequency.set(f + acquisition_controller.demodulation_frequency)

"""Save before running!!!!!"""
savescript1()

#slowlimp
#bzslow

#%% FAST RF 2D scan with ATS and awg: awg voltage vs RF frequency vs S21 in magnetic field ++++++++++++++++++++++++++++++++++++++++++++++++++++

acquisition_controller_fast.update_acquisitionkwargs(
                 samples_per_record=2000000,
                 records_per_buffer=10,
                 buffers_per_acquisition=10)

RF.power.set(-40)

""" Apply magnetic field """
#triton.magnet_sweeprate.set(0.1)
#triton.Bz(0.05)
#triton.magnet_sweeprate.set(0.01)

LP1= -1060
RP1= -985
gates.LP1(LP1)
gates.RP1(RP1)
span = 10
step = span/200         # 200 pixels in RP

awg1.ch1_amp(gate_to_awg(1,span))
awg1.ch1_state(1)
awg1.start()
scanjob = {'sweepdata': {'param':'RP1', 'start':RP1-span/2, 'end':RP1+span/2, 'step':step, 'wait_time':0.00001},
           'stepdata': {'param':'RF.frequency', 'start':f-25e6, 'end':f+20e6, 'step':1e6, 'wait_time':0.00001},
           'minstrument':['acquisition_controller_fast'],'wait_time_startscan':3}
dataset=qtt.scans.RFscan2Dfast(station, scanjob, datafunction=acquisition_controller_fast.acquisition, rescal=rescal, plotparam='S21mag')
ph=MatPlot(dataset.S21mag)
addPPT(plt.gcf().number)

# set the frequency back to resonance    
change_probe_freq(f)

awg1.stop_all()
awg2.stop_all()
#gates.resetgates(gv,gv)

"""Save before running!!!!!"""
savescript1()

#brfff

#%% FAST RF 2D scan with ATS: Bz-field vs awg voltage
acquisition_controller_fast.update_acquisitionkwargs(
                 samples_per_record=1000000,
                 records_per_buffer=10,
                 buffers_per_acquisition=25)

triton.magnet_sweeprate.set(0.05)
triton.Br(0.055)
triton.magnet_sweeprate.set(0.01)

span = 10
step = span/200         # 200 pixels in RP
#LP1=-510
RP1=-622.3
#gates.LP1(LP1)
gates.RP1(RP1)


f_RF_offset=60e6
change_probe_freq(6.90755e9, f_RF_offset, demodulation_tf=False)

period=2e-3
make_sawtooth(f, f_RF_offset, period)
make_fixed_frequency(f, f_RF_offset, period)
awg1.ch1_waveform('sawtooth')
awg1.ch1_amp(gate_to_awg(1,span))
awg1.ch1_state(1)
awg1.ch3_waveform('fixedfreqRF')
awg1.ch4_waveform('fixedfreqLO')
awg1.ch3_state(1)
awg1.ch4_state(1)
awg1.start()

scanjob = {'sweepdata': {'param':'RP1', 'start':RP1-span/2, 'end':RP1+span/2, 'step':step, 'wait_time':0.0001},
           'stepdata': {'param':'Br', 'start':0.055, 'end':0.053, 'step':0.0001, 'wait_time':1},
           'minstrument':['acquisition_controller_fast'],'wait_time_startscan':3}
dataset=qtt.scans.Brscan2Dfast(station, scanjob, datafunction=acquisition_controller_fast.acquisition, rescal=rescal, plotparam='S21mag')
ph1=MatPlot(dataset.S21mag)
addPPT(plt.gcf().number)

awg1.stop_all()
awg2.stop_all()
triton.magnet_sweeprate.set(0.05)
triton.Br(0.075)

# set the frequency back to resonance    
change_probe_freq(f, f_RF_offset, demodulation_tf=False)

"""Save before running!!!!!"""
savescript1()

#magichat
#bzfast



#%% Fast RF 2D scan with ATS: Bz-field vs chirped RF frequency
acquisition_controller_fast.update_acquisitionkwargs(
                 samples_per_record=1000000,
                 records_per_buffer=20,
                 buffers_per_acquisition=50)

#change_probe_freq(6.91941e9)

triton.magnet_sweeprate.set(0.05)
triton.Bz(0.05)
triton.magnet_sweeprate.set(0.02)

RF.power.set(13)
#LP1= -510
#RP1= -655
#gates.RP1(RP1)
#gates.LP1(LP1)
spanf = 30e6
stepf = spanf/100       # 100 pixels in frequency
f3 = f - 5e6

make_RF_chirp(f3,f0=100e6,df=spanf,Vpp=0.08,T=2e-3,phi0=0)
awg1.ch3_waveform('chirp')
awg1.ch3_state(1)
awg1.ch4_waveform('chirp')
awg1.ch4_state(1)

awg1.start()
scanjob = {'sweepdata': {'param':'RF', 'start':f3-spanf/2, 'end':f3+spanf/2, 'step':stepf, 'wait_time':0.0001},
           'stepdata': {'param':'Bz', 'start':0.048, 'end':0.044, 'step':0.0002, 'wait_time':1},
           'minstrument':['acquisition_controller_fast'],'wait_time_startscan':3}
dataset=qtt.scans.Bzscan2DfastRF(station, scanjob, datafunction=acquisition_controller_fast.acquisition, rescal=rescal, plotparam='S21mag')
ph1=MatPlot(dataset.S21mag)
addPPT(plt.gcf().number)

awg1.stop_all()
awg2.stop_all()
triton.magnet_sweeprate.set(0.05)
triton.Bz(0.075)

# set the frequency back to resonance    
change_probe_freq(f)

"""Save before running!!!!!"""
savescript1()

#fastspincoupling


#%% FAST RF 2D scan with ATS: Br-field vs awg voltage (In 3D field, Btheta and Bphi in degrees)
acquisition_controller_fast.update_acquisitionkwargs(
                 samples_per_record=2000000,
                 records_per_buffer=10,
                 buffers_per_acquisition=25)

change_probe_freq(6.91834e9)

Br = 0.051   # radial distance
Btheta = 90 # azimuthal angle
Bphi = 35    # polar angle
sweeprate = 0.1
triton.set_Bspher(Br,Btheta,Bphi,sweeprate)
triton.magnet_sweeprate.set(0.01)

span = 20
step = span/200         # 200 pixels in RP
RF.power.set(-40)
#LP1=0
RP1= -1018
#gates.LP1(LP1)
gates.RP1(RP1)

#awg1.load_awg_file(r'C:\Users\OEM\Desktop\AWG Waveforms\fast_scan.awg')
awg1.ch1_amp(gate_to_awg(1,span))
awg1.ch1_state(1)
awg1.start()
scanjob = {'sweepdata': {'param':'RP1', 'start':RP1-span/2, 'end':RP1+span/2, 'step':step, 'wait_time':0.0001},
           'stepdata': {'param':'Br', 'start':0.051, 'end':0.042, 'step':0.0003, 'wait_time':1},
           'minstrument':['acquisition_controller_fast'],'wait_time_startscan':3}
dataset=qtt.scans.Brscan2Dfast(station, scanjob, datafunction=acquisition_controller_fast.acquisition, rescal=rescal, plotparam='S21mag')
ph1=MatPlot(dataset.S21mag)
addPPT(plt.gcf().number)

awg1.stop_all()
awg2.stop_all()
triton.set_Bspher(0.075,Btheta,Bphi,sweeprate)

# set the frequency back to resonance    
change_probe_freq(f)

"""Save before running!!!!!"""
savescript1()

#brfast1

#%% RF 2D scan with ATS: Bz-field vs RF frequency vs S21
#XX1

acquisition_controller.update_acquisitionkwargs(
                 samples_per_record=1000000,
                 records_per_buffer=1,
                 buffers_per_acquisition=1)

triton.magnet_sweeprate.set(0.05)
triton.Bz(0.0)
#triton.magnet_sweeprate.set(0.004)



#gates.RP1(-536)

# set new (dispersively shifted) resonance frequency 
f_center = f - 5e6



awg1.ch1_waveform('')
awg1.ch2_waveform('')
make_fixed_frequency(f, f_RF_offset=80e6, period=2e-3)
awg1.ch3_waveform('fixedfreqRF')
awg1.ch4_waveform('fixedfreqLO')
awg1.ch3_state(1)
awg1.ch4_state(1)
awg1.start()

scanjob = {'sweepdata': {'param':'RF.frequency', 'start':f_center-15e6, 'end':f_center+15e6, 'step':0.2e6,'wait_time':0.00001},
           'stepdata': {'param':'Bz', 'start':0, 'end':1.0, 'step':0.01, 'wait_time':1},
           'minstrument':['acquisition_controller'],'wait_time_startscan':1}
dataset=qtt.scans.BzRFscan2D(station, scanjob, datafunction=acquisition_controller.acquisition, rescal=rescal, plotparam='S21mag')
ph=MatPlot(dataset.S21mag)
addPPT(plt.gcf().number)

#scanjob = {'sweepdata': {'param':'RF.frequency', 'start':f_center-15e6, 'end':f_center+15e6, 'step':0.2e6,'wait_time':0.00001},
#           'stepdata': {'param':'Bz', 'start':0.061, 'end':0.065, 'step':0.0001, 'wait_time':1},
#           'minstrument':['acquisition_controller'],'wait_time_startscan':1}
#dataset=qtt.scans.BzRFscan2D(station, scanjob, datafunction=acquisition_controller.acquisition, rescal=rescal, plotparam='S21mag')
#ph=MatPlot(dataset.S21mag)
#addPPT(plt.gcf().number)

#scanjob = {'sweepdata': {'param':'RF.frequency', 'start':f2-20e6, 'end':f2+5e6, 'step':0.2e6,'wait_time':0.00001},
#           'stepdata': {'param':'Bz', 'start':0, 'end':2, 'step':0.02, 'wait_time':1},
#           'minstrument':['acquisition_controller'],'wait_time_startscan':1}
#dataset=qtt.scans.BzRFscan2D(station, scanjob, datafunction=acquisition_controller.acquisition, rescal=rescal, plotparam='S21mag')
#ph=MatPlot(dataset.S21mag)
#addPPT(plt.gcf().number)

#scanjob = {'sweepdata': {'param':'RF.frequency', 'start':f1-20e6, 'end':f1+5e6, 'step':0.2e6,'wait_time':0.00001},
#           'stepdata': {'param':'Bz', 'start':0, 'end':2, 'step':0.02, 'wait_time':1},
#           'minstrument':['acquisition_controller'],'wait_time_startscan':1}
#dataset=qtt.scans.BzRFscan2D(station, scanjob, datafunction=acquisition_controller.acquisition, rescal=rescal, plotparam='S21mag')
#ph=MatPlot(dataset.S21mag)
#addPPT(plt.gcf().number)

# set the frequency back to resonance    
#change_probe_freq(f)

awg1.stop()

#triton.magnet_sweeprate.set(0.04)
#triton.Bz(0.075)
#triton.Bz(-0.05)
#triton.Bz(0.04)
#triton.Bz(-0.03)
#triton.Bz(0.02)
#triton.Bz(-0.01)
#triton.Bz(0)

"""Save before running!!!!!"""
savescript1()

#spincoupling

#%% (JJD) RF 2D scan with ATS: Bz-field vs RF frequency vs S21


acquisition_controller.update_acquisitionkwargs(
                 samples_per_record=2000000,
                 records_per_buffer=1,
                 buffers_per_acquisition=1)

triton.magnet_sweeprate.set(0.04)
triton.Bz(0.049)
triton.magnet_sweeprate.set(0.005)

gates.RP1(-643)

# set new (dispersively shifted) resonance frequency 
f_center = f1
#f_center = 6.908e9
span = 30e6

RF.power.set(-40)

awg1.ch4_state(1)
awg1.start()
scanjob = {'sweepdata': {'param':'RF.frequency', 'start':f_center-span/2, 'end':f_center+span/2, 'step':0.5e6,'wait_time':0.00001},
           'stepdata': {'param':'Bz', 'start':0.049, 'end':0.044, 'step':0.0002, 'wait_time':0.1},
           'minstrument':['acquisition_controller'],'wait_time_startscan':5}
dataset=qtt.scans.BzRFscan2D(station, scanjob, datafunction=acquisition_controller.acquisition, rescal=rescal, plotparam='S21mag')
ph=MatPlot(dataset.S21mag)
addPPT(plt.gcf().number)


# set the frequency back to resonance    
change_probe_freq(f)

awg1.stop_all()
awg2.stop_all()
triton.magnet_sweeprate.set(0.04)
triton.Bz(0.075)


#triton.magnet_sweeprate.set(0.1)
#triton.Bz(0.01)
#triton.Bz(-0.05)
#triton.Bz(0.04)
#triton.Bz(-0.03)
#triton.Bz(0.02)
#triton.Bz(-0.01)
#triton.Bz(0)

"""Save before running!!!!!"""
savescript1()

#spincoupling2

#%% RF 2D scan with ATS: Bx-field vs RF frequency vs S21

acquisition_controller.update_acquisitionkwargs(
                 samples_per_record=2000000,
                 records_per_buffer=1,
                 buffers_per_acquisition=1)

triton.magnet_sweeprate.set(0.004)

# set new (dispersively shifted) resonance frequency 
#f1 = 5.70189e9

RF.power.set(-40)

awg1.ch4_state(1)
awg1.start()
scanjob = {'sweepdata': {'param':'RF.frequency', 'start':6.998e9, 'end':7.011e9, 'step':0.03e6,'wait_time':0.00001},
           'stepdata': {'param':'Bx', 'start':0.00, 'end':0.06, 'step':0.002, 'wait_time':1},
           'minstrument':['acquisition_controller'],'wait_timeS_startscan':1}
dataset=qtt.scans.BxRFscan2D(station, scanjob, datafunction=acquisition_controller.acquisition, rescal=rescal, plotparam='S21mag')
ph1=MatPlot(dataset.S21mag)
addPPT(plt.gcf().number)

# set the frequency back to resonance    
RF.frequency.set(f)
LO.frequency.set(f + acquisition_controller.demodulation_frequency)

awg1.stop_all()
awg2.stop_all()
triton.magnet_sweeprate.set(0.05)
triton.Bx(0)
triton.Bz(0)

"""Save before running!!!!!"""
savescript1()


#%% 2D scan with ATS: B-field vs mw frequency vs S21

acquisition_controller.update_acquisitionkwargs(
                 samples_per_record=4096,
                 records_per_buffer=20,
                 buffers_per_acquisition=100)

RF.power.set(-40)
mw.power.set(-10)

# set new (dispersively shifted) resonance frequency 
#f1 = 5.70398e9
#RF.frequency.set(f1)
#LO.frequency.set(f1 + acquisition_controller.demodulation_frequency)

RP=22.1
gates.RP(RP)

mw.on()
awg1.ch4_state(1)
awg1.start()
scanjob = {'sweepdata': {'param':'mw.frequency', 'start':13.6e9, 'end':14.6e9, 'step':0.25e6,'wait_time':0.00001},
           'stepdata': {'param':'Bz', 'start':.4, 'end':0.41, 'step':0.0002, 'wait_time':1},
           'minstrument':['acquisition_controller'],'wait_time_startscan':1}
dataset=qtt.scans.Bzmwscan2D(station, scanjob, datafunction=acquisition_controller.acquisition, rescal=rescal, plotparam='S21mag')
ph = MatPlot(dataset.S21mag)
addPPT(plt.gcf().number)
ph = MatPlot(dataset.S21phase)
addPPT(plt.gcf().number)

mw.off()
awg1.stop_all()
awg2.stop_all()
mw.frequency.set(1e6)

# set the frequency back to resonance    
RF.frequency.set(f)
LO.frequency.set(f + acquisition_controller.demodulation_frequency)

#triton.Bz(0.01)
#triton.Bz(-0.05)
#triton.Bz(0.04)
#triton.Bz(-0.03)
#triton.Bz(0.02)
#triton.Bz(-0.01)
#triton.Bz(0)

"""Save before running!!!!!"""
savescript1()

#2DmwBz


#%% 2D scan: RF power vs RF frequency vs S21

acquisition_controller.update_acquisitionkwargs(
                 samples_per_record=2000000,
                 records_per_buffer=10,
                 buffers_per_acquisition=1)

awg1.ch4_state(1)
awg1.start()
scanjob = {'sweepdata': {'param':'RF.frequency', 'start':f-20e6, 'end':f+20e6, 'step':0.4e6,'wait_time':0.00001},
           'stepdata': {'param':'RF.power', 'start':-60, 'end':-30, 'step':3, 'wait_time':0.00001},
           'minstrument':['acquisition_controller'],'wait_time_startscan':0.1}
dataset=qtt.scans.RFpowerscan2D(station, scanjob, datafunction=acquisition_controller.acquisition, rescal=rescal, plotparam='S21mag')
ph1 = MatPlot(dataset.S21mag)
addPPT(plt.gcf().number)

#set the frequency back to resonance
RF.frequency.set(f)
LO.frequency.set(f + acquisition_controller.demodulation_frequency)

RF.power(-40)
awg1.stop_all()
awg2.stop_all()

"""Save before running!!!!!"""
savescript1()

#plot normalized transmissions ++++ unfinished, need to add correct axes ++++
#ph3 = MatPlot(dataset.S21mag/dataset.S21mag.max(1)[:,None])


#%% FAST mw 2D scan with ATS and awg: AWG voltage vs MW frequency vs S21  ++++++++++++++++++++++++++++++++++++++++++++++++++++
period = 4e-3
step_pts = 50
sweep_pts = 200
n_samples = round(period*ats_inst.get_sample_rate())
acquisition_controller_fast.update_acquisitionkwargs(
                 samples_per_record=n_samples,
                 records_per_buffer=10,
                 buffers_per_acquisition=10)

span = 14

#LP1= -601
RP1= -642
#gates.LP1(LP1)
gates.RP1(RP1)

mw1.power(-9)
mw1.fmstate('off')
mw1.on()

f_RF_offset = 60e6
rf_power = -47.5
f_disp1 = 6.9085e9-1.5e6*0
sweep_item1 = AwgChannelScanItem(awg_name='awg1', ch_name='ch1', wf_type='sawtooth_fast', amplitude=gate_to_awg(1,span))
prepare_awg1_awg2_seq_sync(f_start=f_disp1, f_RF_offset=f_RF_offset, period=period, rf_power=rf_power, 
                           acq_ctrl=acquisition_controller_fast,
                           item1=sweep_item1)

scanjob = {'sweepdata': {'param':'RP1', 'start':RP1-span/2, 'end':RP1+span/2, 'step':span/sweep_pts, 'wait_time':1e-6},
           'stepdata': {'param':'mw1.frequency', 'start':12e9, 'end':16e9, 'step':20e6, 'wait_time':50e-3},
           'minstrument':['acquisition_controller_fast'],'wait_time_startscan':3}
dataset=qtt.scans.mw1scan2Dfast(station, scanjob, datafunction=acquisition_controller_fast.acquisition, rescal=rescal, plotparam='S21mag')
ph1=MatPlot(dataset.S21mag)
plt.ylabel('MW1 frequency (Hz)')
addPPT(plt.gcf().number)
#ph2=MatPlot(dataset.S21phase)
#addPPT(plt.gcf().number)

# Plot phase
z_data = dataset.S21phase.ndarray.copy()
val, idx = find_closest(dataset.RP1.ndarray, RP1)
z_data = anglewrap_180( z_data - anglemean_180(z_data[:,idx]) )
title = ds.metadata['scantime'][0:10] + '/' + os.path.split(ds.location)[1]
plot_dispersive_phase(dataset.RP1.ndarray, dataset.frequency.ndarray, z_data, 
                        dataset.RP1.label, dataset.frequency.label, dataset.S21phase.label, title, clim=[-45,45])
addPPT(plt.gcf().number)

awg1.stop_all()
awg2.stop_all()
mw1.off()
mw1.frequency(10e6)

"""Save before running!!!!!"""
savescript1()
#mfff
#2Dmwfast

#%% TURBO mw 2D scan with ATS and awg: AWG voltage vs MW frequency vs S21  ++++++++++++++++++++++++++++++++++++++++++++++++++++
### mw1 source
"""
Note: Before running this script make sure AWG Channel 2 is NOT connected to DQD2!!!

"""


acquisition_controller_fast.update_acquisitionkwargs(
                 samples_per_record=1000000*2,
                 records_per_buffer=10,
                 buffers_per_acquisition=600)


#RF.power(-40)
#mw1.power(-18)

span = 14
step = span/100         # 200 pixels in RP
#LP1= -60
RP1= -639
#gates.LP1(LP1)
gates.RP1(RP1)

#mw1.on()
start_mw_frequency = 6.93e9
mwspan = 60e6
mw1.frequency(start_mw_frequency+mwspan/2)
mw1.fmstate('ON')
mw1.on()
mw1.power(-27)

f_RF_offset=80e6
change_probe_freq(6.905e9, f_RF_offset, demodulation_tf=False)

period=(2e-3)*1
make_sawtooth(f, f_RF_offset, period)
make_turbosawtooth(f, f_RF_offset, period)
make_fixed_frequency(f, f_RF_offset, period, rf_power=-50)

awg1.ch1_waveform('sawtoothturbo')
awg1.ch1_amp(gate_to_awg(1,span))
awg1.ch1_state(1)

awg1.ch2_waveform('sawtooth')
awg1.ch2_offset(0)
awg1.ch2_amp(4)
awg1.ch2_state(1)

awg1.ch3_waveform('fixedfreqRF')
awg1.ch4_waveform('fixedfreqLO')
awg1.ch3_state(1)
awg1.ch4_state(1)
awg1.start()

scanjob = {'sweepdata': {'param':'RP1', 'start':RP1-span/2, 'end':RP1+span/2, 'step':step, 'wait_time':0.0001},
           'stepdata': {'param':'MF', 'start':start_mw_frequency, 'end':start_mw_frequency + mwspan, 'step':mwspan/100, 'wait_time':0.00001},
           'minstrument':['acquisition_controller_fast'],'wait_time_startscan':3}
dataset=qtt.scans.scan2DresonatorturboRF(station, scanjob, datafunction=acquisition_controller_fast.acquisition, rescal=rescal, plotparam='S21mag',clip_first_point=True)
ph1=MatPlot(dataset.S21mag)
addPPT(plt.gcf().number)
#ph2=MatPlot(dataset.S21phase)
#addPPT(plt.gcf().number)

z_data = dataset.S21phase.ndarray.copy()
val, idx=find_closest(dataset.RP1.ndarray, RP1)
z_zero = anglemean_180(z_data[:,idx])  
#        z_data = (z_data+180)%(2*180)-180
z_data = z_data-z_zero
plot_dispersive_phase(dataset.RP1.ndarray, dataset.frequency.ndarray, z_data, 
                        dataset.RP1.label, dataset.frequency.label, dataset.S21phase.label, os.path.split(dataset.location)[1], clim=[-20,20])
addPPT(plt.gcf().number)

#plt.figure()
#plt.plot(dataset.S21mag[50,:])

awg1.stop_all()
awg2.stop_all()
mw1.fmstate('OFF')
mw1.off()
#mw1.frequency(1e6)

### set the frequency back to resonance ###
change_probe_freq(f, f_RF_offset, demodulation_tf=False)

"""Save before running!!!!!"""
savescript1()

#mttt
#2Dmwturbo




#%% TURBO mw 2D scan with ATS and awg: AWG voltage vs MW frequency vs S21  ++++++++++++++++++++++++++++++++++++++++++++++++++++
### mw1 source
"""
Note: Before running this script make sure AWG Channel 2 is NOT connected to DQD2!!!

"""



span = 14
span_turbo = 7
step = span/100         # 200 pixels in RP
#LP1= -60
#RP1= -636
#gates.LP1(LP1)
gates.RP1(RP1)
spanf =20e6
stepf = spanf/100       # 100 pixels in frequency
f_center = 6.910e9
F_REF = 6.915e9


#b = 4.661e9 for upper branch, b= 4.653e9 for lower branch
#b_fields = np.arange(53.8e-3, 48e-3, -0.1e-3)
b_fields = [55.5e-3]
mw1_powers = np.arange(-15, -45, -0.5)
#mw1_powers = [-37]
#delta_f = 0.042e9*(b_fields[0]-b_fields[1])*1000 
#delta_f_corrected = round(delta_f/0.6e6)*0.6e6 
center_pump_frequency = 0.042e9*b_fields[0]*1000 + (4.658e9) 
center_pump_frequency_corrected = round(center_pump_frequency/0.6e6)*0.6e6
for mw1_power in mw1_powers:
    
    for b_field in b_fields:
#        triton.Br(b_field)
    
        acquisition_controller_fast.update_acquisitionkwargs(
                         samples_per_record=1000000*2,
                         records_per_buffer=10,
                         buffers_per_acquisition=50)
        
        #make dispersive shift scan, fit for zero detuning and probe freq
        make_RF_chirp(f_start=f_center-spanf/2, df=spanf, f_RF_offset=40e6, period=(2e-3)*4, rf_power=-47.5)
        awg1.ch1_waveform('sawtoothturbo')
        awg1.ch1_amp(gate_to_awg(1,span))
        awg1.ch1_state(1)
        awg1.ch2_waveform('')
        awg1.ch2_state(0)
        awg1.ch3_waveform('chirpRF')
        awg1.ch3_state(1)
        awg1.ch4_waveform('chirpLO')
        awg1.ch4_state(1)
        awg1.start()
    
        scanjob = {'sweepdata': {'param':'RP1', 'start':RP1-span/2, 'end':RP1+span/2, 'step':step, 'wait_time':0.00001},
               'stepdata': {'param':'RF', 'start':(f_center)-spanf/2, 'end':(f_center)+spanf/2, 'step':stepf, 'wait_time':0.00001},
               'minstrument':['acquisition_controller_fast'],'wait_time_startscan':3}
        
        dataset = qtt.scans.scan2DresonatorturboRF(station, scanjob, datafunction=acquisition_controller_fast.acquisition, rescal=rescal, plotparam='S21mag',clip_first_point=True)
        ds = dataset
        ph1=MatPlot(ds.S21mag)
        #addPPT(plt.gcf().number)
        awg1.stop_all()
        awg2.stop_all()

        
        # Fit for zero detuning
        xdata = ds.RP1.ndarray[1,:]
        val, idx = find_closest(ds.frequency.ndarray, F_REF)
        ydata = ds.S21mag.ndarray[idx,:]
        popt, perr, doubletanh = fit_doubletanh(xdata, ydata)
        x0 = np.mean(popt[3:5])
        title = ds.metadata['scantime'][0:10] + '/' + os.path.split(ds.location)[1]
        # Fano fit on center linecut
        xdata2 = ds.frequency.ndarray
        val, idx = find_closest(ds.RP1.ndarray[1,:], x0)
        ydata2 = ds.S21mag.ndarray[:,idx]
        popt2, perr2, fano_peak = fit_fano(xdata, ydata, EXPONENT=1)
        # Plot
        plot_center_and_fano_fit(ds.RP1.ndarray, ds.frequency.ndarray, ds.S21mag.ndarray, 
                                 ds.RP1.label, ds.frequency.label, ds.S21mag.label, title,
                                 xdata, ydata, doubletanh, popt, F_REF, x0,
                                 xdata2, ydata2, fano_peak, popt2)
        addPPT(plt.gcf().number)
        print('x0 = {:.4g} mV, f0 = {:.5g} GHz, fwhm = {:.2g} MHz'.format(x0, popt3[0]/1e9, popt3[1]/1e6))
    
        
        #set x0 to fitted zero detuning
        if (-700 <= x0) & (x0 <= -550):
            gates.RP1(x0)
            RP1 = gates.RP1()
            print(x0)
        else:
            print('x0 outside of bounds, breaking loop')
            
            
            
        #make turbo two tone scan
        acquisition_controller_fast.update_acquisitionkwargs(
                         samples_per_record=1000000*2,
                         records_per_buffer=10,
                         buffers_per_acquisition=400)        
    
        
        if b_field != b_fields[0]:
            center_pump_frequency_corrected = center_pump_frequency_corrected - delta_f_corrected
        
#        center_pump_frequency_corrected = center_pump_frequency_corrected + 60e6
        mw1.frequency(center_pump_frequency_corrected)
        mw1.fmstate('ON')
        mw1.on()
        mw1.power(mw1_power)
        f_RF_offset_twotone= 80e6
        
        change_probe_freq(popt[0], f_RF_offset=f_RF_offset_twotone, demodulation_tf=False)
        period=(4e-3)*1
        
        make_sawtooth(f, f_RF_offset=f_RF_offset_twotone, period=8e-3)
        make_turbosawtooth(f, f_RF_offset=f_RF_offset_twotone, period=8e-3)
        make_fixed_frequency(f, f_RF_offset=f_RF_offset_twotone, period=8e-3, rf_power=-47.5)
        
        awg1.ch1_waveform('sawtoothturbo')
        awg1.ch1_amp(gate_to_awg(1,span_turbo))
        awg1.ch1_state(1)
        
        awg1.ch2_waveform('sawtooth')
        awg1.ch2_offset(0)
        awg1.ch2_amp(4)
        awg1.ch2_state(1)
        awg1.ch3_waveform('fixedfreqRF')
        awg1.ch4_waveform('fixedfreqLO')
        awg1.ch3_state(1)
        awg1.ch4_state(1)
        awg1.start()
        
        scanjob = {'sweepdata': {'param':'RP1', 'start':RP1-span/2, 'end':RP1+span/2, 'step':step, 'wait_time':0.0001},
                   'stepdata': {'param':'MF', 'start':center_pump_frequency_corrected-30e6, 'end':center_pump_frequency_corrected + 30e6, 'step':60e6/100, 'wait_time':0.00001},
                   'minstrument':['acquisition_controller_fast'],'wait_time_startscan':3}
        dataset=qtt.scans.scan2DresonatorturboRF(station, scanjob, datafunction=acquisition_controller_fast.acquisition, rescal=rescal, plotparam='S21mag',clip_first_point=True)
        ph1=MatPlot(dataset.S21mag)
        addPPT(plt.gcf().number)
        
        z_data = dataset.S21phase.ndarray.copy()
        val, idx=find_closest(dataset.RP1.ndarray, RP1)
        z_zero = anglemean_180(z_data[:,idx])  
#        z_data = (z_data+180)%(2*180)-180
        z_data = z_data-z_zero
        plot_dispersive_phase(dataset.RP1.ndarray, dataset.frequency.ndarray, z_data, 
                                dataset.RP1.label, dataset.frequency.label, dataset.S21phase.label, os.path.split(dataset.location)[1], clim=[-10,10])
        addPPT(plt.gcf().number)
        
        savescript1()
        awg1.stop_all()
        awg2.stop_all()

        mw1.fmstate('OFF')
        mw1.off()
        plt.close('all')




"""Save before running!!!!!"""
savescript1()
#triton.Br(0.075)
#mtttautomatic
#2Dmwturbo

#%% FAST mw 2D scan with ATS and awg: awg voltage vs mw frequency vs S21  ++++++++++++++++++++++++++++++++++++++++++++++++++++
### mw2 source
acquisition_controller_fast.update_acquisitionkwargs(
                 samples_per_record=2000000,
                 records_per_buffer=10,
                 buffers_per_acquisition=10)

### new probe frequency ###
change_probe_freq(f3 = 6.9123e9)

RF.power.set(-40)
mw2.power.set(-10)

span = 20
step = span/200         # 200 pixels in RP
#LP1= -60
#RP1= -429
#gates.LP1(LP1)
#gates.RP1(RP1)

mw2.on()
#awg1.load_awg_file(r'C:\Users\OEM\Desktop\AWG Waveforms\fast_scan.awg')
awg1.ch1_amp(gate_to_awg(1,span))
awg1.ch1_state(1)
awg1.start()
scanjob = {'sweepdata': {'param':'RP1', 'start':RP1-span/2, 'end':RP1+span/2, 'step':step, 'wait_time':0.0001},
           'stepdata': {'param':'mw2.frequency', 'start':1.95e9, 'end':2e9, 'step':1e6, 'wait_time':0.00001},
           'minstrument':['acquisition_controller_fast'],'wait_time_startscan':1}
dataset=qtt.scans.mw2scan2Dfast(station, scanjob, datafunction=acquisition_controller_fast.acquisition, rescal=rescal, plotparam='S21mag')
ph1=MatPlot(dataset.S21mag)
plt.ylabel('MW2 frequency (Hz)')
addPPT(plt.gcf().number)
#ph2=MatPlot(dataset.S21phase)
#addPPT(plt.gcf().number)

awg1.stop_all()
awg2.stop_all()
mw2.off()
mw2.frequency.set(1e6)

### set the frequency back to resonance ###
RF.frequency.set(f)
LO.frequency.set(f + acquisition_controller.demodulation_frequency)

"""Save before running!!!!!"""
savescript1()

#m1fff2
#2Dmwfast


#%% FAST mw 2D scan with ATS and awg: awg voltage vs mw power vs S21  ++++++++++++++++++++++++++++++++++++++++++++++++++++

acquisition_controller_fast.update_acquisitionkwargs(
                 samples_per_record=2000000,
                 records_per_buffer=10,
                 buffers_per_acquisition=50)

RF.power.set(-40)

f2 = 3.995e9
RF.frequency.set(f2)
LO.frequency.set(f2 + acquisition_controller.demodulation_frequency)

#mw1.frequency.set(17.4693e9)
mw1.on()

#LP1=-250
#RP1=17.5
#gates.LP1(LP1)
#gates.RP1(RP1)
span = 12
step = span/200         # 200 pixels in RP

awg1.ch1_amp(gate_to_awg(1,span))
awg1.ch1_state(1)
awg1.start()
scanjob = {'sweepdata': {'param':'RP1', 'start':RP1-span/2, 'end':RP1+span/2, 'step':step, 'wait_time':0.0001},
           'stepdata': {'param':'mw1.power', 'start':-20, 'end':15, 'step':0.1, 'wait_time':0.00001},
           'minstrument':['acquisition_controller_fast'],'wait_time_startscan':1}
dataset=qtt.scans.mwscan2Dpowerfast(station, scanjob, datafunction=acquisition_controller_fast.acquisition, rescal=rescal, plotparam='S21mag')
ph1=MatPlot(dataset.S21mag)
plt.ylabel('MW1 power (dBm)')
addPPT(plt.gcf().number)
#ph2=MatPlot(dataset.S21phase)
#addPPT(plt.gcf().number)

mw1.off()
awg1.stop_all()
awg2.stop_all()
mw1.frequency(1e6)

# set the frequency back to resonance    
#RF.frequency.set(f)
#LO.frequency.set(f + acquisition_controller.demodulation_frequency)

"""Save before running!!!!!"""
savescript1()

#2Dmwpowerfast


#%% 2D scan with ATS: 2nd tone mw frequency vs voltage vs S21, resonator drive frequency fixed

acquisition_controller.update_acquisitionkwargs(
                 samples_per_record=2000000,
                 records_per_buffer=1,
                 buffers_per_acquisition=1)


### new probe frequency ###
f1 = 7.01645e9
RF.frequency.set(f1)
LO.frequency.set(f1 + acquisition_controller.demodulation_frequency)

RF.power(-30)
mw1.power.set(-5)

RP1 = -430
span = 5

mw1.on()
awg1.ch4_state(1)
awg1.start()
scanjob = {'sweepdata': {'param':'mw1.frequency', 'start':7.2e9, 'end':10e9, 'step':20e6,'wait_time':0.00001},
           'stepdata': {'param':'RP1', 'start':RP1-span/2, 'end':RP1+span/2, 'step':0.2, 'wait_time':0.05},
           'minstrument':['acquisition_controller'],'wait_time_startscan':5}
dataset=qtt.scans.mw1scan2D(station, scanjob, datafunction=acquisition_controller.acquisition, rescal=rescal, liveplotwindow=plotQ, plotparam='S21mag')
ph1=MatPlot(dataset.S21mag)
addPPT(plt.gcf().number)
ph2=MatPlot(dataset.S21phase)
addPPT(plt.gcf().number)

mw1.off()
awg1.stop_all()
awg2.stop_all()
mw1.frequency(1e6)

### set the frequency back to resonance ###
RF.frequency.set(f)
LO.frequency.set(f + acquisition_controller.demodulation_frequency)

"""Save before running!!!!!"""
savescript1()

#msss

#%% 2D scan with ATS: 2nd tone mw frequency vs resonator RF frequency vs S21

acquisition_controller.update_acquisitionkwargs(
                 samples_per_record=2000000,
                 records_per_buffer=1,
                 buffers_per_acquisition=1)

RF.power.set(-40)
mw.power.set(6.15)

mw.on()
awg1.ch4_state(1)
awg1.start()
scanjob = {'sweepdata': {'param':'RF.frequency', 'start':2e9, 'end':10e9, 'step':5e6,'wait_time':0.00001},
           'stepdata': {'param':'mw.frequency', 'start':7.5e9, 'end':8.3e9, 'step':2e6,'wait_time':0.00001},
           'minstrument':['acquisition_controller'],'wait_time_startscan':1}
dataset=qtt.scans.RFmwscan2D(station, scanjob, datafunction=acquisition_controller.acquisition, rescal=rescal, liveplotwindow=plotQ, plotparam='S21mag')
ph = MatPlot(dataset.S21mag)
plt.xlabel('RF frequency (Hz)')
plt.ylabel('MW frequency (Hz)')
addPPT(plt.gcf().number)

mw.off()
awg1.stop_all()
awg2.stop_all()
mw.frequency.set(1e6)

#set the frequency back to resonance    
RF.frequency.set(f)
LO.frequency.set(f + acquisition_controller.demodulation_frequency)

"""Save before running!!!!!"""
savescript1()

#fvsf


#%% 2D scan with ATS: 2nd tone mw power vs resonator RF frequency vs S21

acquisition_controller.update_acquisitionkwargs(
                 samples_per_record=2000000,
                 records_per_buffer=1,
                 buffers_per_acquisition=1)

RF.power.set(-40)
mw.frequency.set(8.165e9)

mw.on()
awg1.ch4_state(1)
awg1.start()
scanjob = {'sweepdata': {'param':'RF.frequency', 'start':2e9, 'end':10e9, 'step':5e6,'wait_time':0.00001},
           'stepdata': {'param':'mw.power', 'start':3, 'end':10, 'step':0.1,'wait_time':0.00001},
           'minstrument':['acquisition_controller'],'wait_time_startscan':1}
dataset=qtt.scans.RFmwpowerscan2D(station, scanjob, datafunction=acquisition_controller.acquisition, rescal=rescal, liveplotwindow=plotQ, plotparam='S21mag')
ph = MatPlot(dataset.S21mag)
plt.xlabel('RF frequency (Hz)')
plt.ylabel('MW power (dBm)')
addPPT(plt.gcf().number)

mw.off()
awg1.stop_all()
awg2.stop_all()

#set the frequency back to resonance    
RF.frequency.set(f)
LO.frequency.set(f + acquisition_controller.demodulation_frequency)

"""Save before running!!!!!"""
savescript1()

#mwpowervsf


#%% 1D scan with ATS: S21 vs 2nd tone mw frequency scan, resonator drive frequency fixed, for charge

acquisition_controller.update_acquisitionkwargs(
                 samples_per_record=2000000,
                 records_per_buffer=10,
                 buffers_per_acquisition=1)

RF.power.set(-40)
mw.power.set(-10)

#set to new (shifted) resonance frequency
f1 = 4.00548e9
RF.frequency.set(f1)
LO.frequency.set(f1 + acquisition_controller.demodulation_frequency)

RP1=-162
gates.RP1(RP1)

mw.on()
awg1.ch4_state(1)
awg1.start()
scanjob = {'sweepdata': {'param':'mw.frequency', 'start':0.15e9, 'end':0.24e9, 'step':1e6,'wait_time':0.000001},
           'minstrument':['acquisition_controller']}
dataset=qtt.scans.mwscan1D(station, scanjob, datafunction=acquisition_controller.acquisition, liveplotwindow=plotQ, plotparam='S21mag')
ph=MatPlot(dataset.S21mag)
addPPT(plt.gcf().number)
#ph=MatPlot(dataset.S21phase)

mw.off()
awg1.stop_all()
awg2.stop_all()
mw.frequency.set(1e8)

#set the frequency back to resonance
RF.frequency.set(f)
LO.frequency.set(f + acquisition_controller.demodulation_frequency)

"""Save before running!!!!!"""
savescript1()

#1Dmwcharge


#%% 1D scan with ATS: S21 vs 2nd tone mw frequency scan, resonator drive frequency fixed, for spin

acquisition_controller.update_acquisitionkwargs(
                 samples_per_record=2000000,
                 records_per_buffer=10,
                 buffers_per_acquisition=5)

RF.power.set(-60)
mw.power.set(-10)

#generate_pulsescheme_rabi2(10e-6)
mw.off()
awg1.ch4_state(1)
awg1.start()


#set to new (shifted) resonance frequency
f1 = 5.70445e9
RF.frequency.set(f1)
LO.frequency.set(f1 + acquisition_controller.demodulation_frequency)

#
#for pwr in np.arange(-20,-30,-2):
#    mw.power.set(pwr)
#for f1 in np.arange(6.0424e9,6.0426e9,1e5):
#    RF.frequency.set(f1)
#    LO.frequency.set(f1 + acquisition_controller.demodulation_frequency)
#for k in np.arange(0,4,1):
scanjob = {'sweepdata': {'param':'mw.frequency', 'start':5.73e9, 'end':5.775e9, 'step':0.2e6,'wait_time':0.00001},
           'minstrument':['acquisition_controller']}
dataset=qtt.scans.mwscan1D(station, scanjob, datafunction=acquisition_controller.acquisition, plotparam='S21mag')
#ph=MatPlot(dataset.S21mag)
add_B_to_plot()
add_B_to_phaseplot()
    
    
awg1.stop()
awg1.ch4_state(0)
mw.off()
mw.frequency.set(1e8)

#set the frequency back to resonance
#RF.frequency.set(f)
#LO.frequency.set(f + acquisition_controller.demodulation_frequency)

#1Dmwspin


#%% 1D scan with ATS: S21 vs 2nd tone mw power scan, resonator drive frequency fixed, for TWPA characterization

acquisition_controller.update_acquisitionkwargs(
                 samples_per_record=2000000,
                 records_per_buffer=1,
                 buffers_per_acquisition=1)

f1 = 6.5e9
RF.power.set(-40)
RF.frequency.set(f1)
LO.frequency.set(f1 + acquisition_controller.demodulation_frequency)
mw.frequency(8.2e9)

mw.on()
awg1.ch4_state(1)
awg1.start()
scanjob = {'sweepdata': {'param':'mw.power', 'start':0, 'end':15, 'step':0.01,'wait_time':0.000001},
           'minstrument':['acquisition_controller']}
dataset=qtt.scans.mwpowerscan1D(station, scanjob, datafunction=acquisition_controller.acquisition, liveplotwindow=plotQ, plotparam='S21mag')
ph=MatPlot(dataset.S21mag)
plt.xlabel('MW power (dBm)')
addPPT(plt.gcf().number)

mw.off()
awg1.stop_all()
awg2.stop_all()
mw.frequency.set(1e6)

"""Save before running!!!!!"""
savescript1()

#TWPA


#%% 1D scan with ATS: S21 vs measurement time; With pulsing; T1 measurement & histogram

from imp import reload
reload(qtt.scans)

det = gate_to_awg(15)
unloadRP = gate_to_awg(0)
unloadLP = gate_to_awg(0)
generate_pulsescheme_loading_compensation(3e-3,100e-6,1000e-6,100e-6,-1100e-6,[unloadRP,unloadLP],[det,-det])
#time.sleep(10)
awg1.ch2_state(0)


#pos1 = [gate_to_awg(0), gate_to_awg(-1)]
#pos2 = [gate_to_awg(0), gate_to_awg(0)]
#pos3 = [gate_to_awg(15), gate_to_awg(0)]
#generate_pulsescheme_loading_4stage(3e-3,100e-6,50e-6,1e-3,1000e-6,-2.2e-3,pos1,pos2,pos3)
#"""t_total,t_1,t_2,t_3,t_comp,delay,pos1(ch1,ch2),pos2,pos3"""

t_meas = 768e-6
step = 1e-6

rpb = 40
bpa = 10
num_acq = 10
rec_per_acq = rpb*bpa # number of records per acquisition
acquisition_controller_t.update_acquisitionkwargs(
                 samples_per_record=int(t_meas*1e9),
                 records_per_buffer=rpb,
                 buffers_per_acquisition=bpa)

RF.power.set(-40)

RP=-40.5-16
#gates.LP(LP)
gates.RP(RP)

#awg1.ch4_state(1)
#awg1.start()

scanjob = {'sweepdata': {'param':'t_measurement', 'start':0, 'end':t_meas, 'step':step,'wait_time':0.001},
           'minstrument':['acquisition_controller_t'],'wait_time_startscan':5}
dataset=qtt.scans.pulsescheme1D_timetrace(station, scanjob, datafunction=acquisition_controller_t.acquisition, num_acq=num_acq, rec_per_acq=rec_per_acq, plotparam='S21mag')
ph=MatPlot(dataset.S21mag)
#ph=MatPlot(dataset.S21phase)

awg1.stop_all()
awg2.stop_all()

#p = fit_T1(dataset,205)   #(dataset,number of first points to exclude)
#plot_fit_T1(p,unloadRP,unloadLP,det)

"""Save before running!!!!!"""
savescript1()
copyh5file()
#plot_hist(dataset,plotphase=0,n_start=53,n_ave=6,bins=50)

plt.figure()
plt.imshow(SingleShotMag[0:500])
plt.xlabel('time (us)')
plt.ylabel('trace #')
plt.colorbar()

""" plot single traces"""
#plt.figure()
#plt.plot(SingleShotMag[90])
#plt.clf()
#plt.plot(np.average(SingleShotPhase[:100],axis=0))

# timetracee

#%%
from scipy import signal
 
# put here the array you want to correct
my_array = np.zeros(100000)
my_array[10000:20000] = -1
my_array[60000:70000] = 1


sample_rate =  1e9 # sample/sec (of AWG)
nyq_rate = sample_rate / 2.0

# 500KHz bias T
cutoff_hz = 10e3#/(2*np.pi) # 50Hz cut off (3db point)

# filter of dac
b, a = signal.bessel(1, cutoff_hz/nyq_rate, 'high') # b and a define the transfer function

effect_of_bias_T = signal.lfilter(b,a,my_array) # apply transfer function to input signal
#effect_of_bias_T[10000:20000] += -1
biasT_corrected_signal = signal.lfilter(a,b, my_array) # invert transfer function to modify input signal

signal_after_biasT = signal.lfilter(b,a, biasT_corrected_signal) # apply transfer function to modified input signal

# uncorrected data
plt.figure()
plt.plot(my_array, label='signal AWG')
plt.plot(effect_of_bias_T, label='signal after biasT')
plt.legend()

# corrected data
plt.figure()
plt.plot(biasT_corrected_signal, label='modified signal AWG')
plt.plot(signal_after_biasT, label='signal after biasT')
plt.legend()
plt.show()

#%% plot old single-shot traces and histograms
dir_old = r'K:\ns\qt\spin-qubits\data\QClab_Vandersypen3\SQ17_93_1_Da2x2\2018-10-04\18-13-33_qtt_pulsescheme1D_timetrace'
dataset_old = qcodes.load_data(dir_old)
h5_old = h5py.File(dir_old+'\single-shot_traces.h5','r')
SingleShotMag_old = h5_old['S21mag']
SingleShotPhase_old = h5_old['S21phase']

plot_singletraces(dataset_old,n_start=0,n_end=1000)

plot_hist(dataset_old,plotphase=1,n_start=30,n_ave=300,bins=50)

#%% 1D scan with ATS: S21 vs microwave burst time scan, Rabi oscillations
from imp import reload
reload(qtt.scans)
acquisition_controller_t.update_acquisitionkwargs(
                 samples_per_record=1024,
                 records_per_buffer=10000, 
                 buffers_per_acquisition=100)


RF.power.set(-60)
mw.power.set(-130)

###
f1 = 5.70402e9
RF.frequency.set(f1)
LO.frequency.set(f1 + acquisition_controller.demodulation_frequency)
###


#mw.on()
awg1.ch3_state(1)
mw.frequency.set(5.7517e9)
scanjob = {'sweepdata': {'param':'t_burst', 'start':1e-9, 'end':0.1001e-6, 'step':0.001e-6,'wait_time':0.0001},
           'minstrument':['acquisition_controller']}
dataset=qtt.scans.Rabiscan1D1(station, scanjob, datafunction=acquisition_controller_t.acquisition, plotparam='S21mag')
ph=MatPlot(dataset.S21mag)
ph=MatPlot(dataset.S21phase)


awg1.ch3_state(0)
awg1.ch1_state(0)
awg1.stop()
mw.off()
mw.frequency.set(1e6)


#set the frequency back to resonance
RF.frequency.set(f)
LO.frequency.set(f + acquisition_controller.demodulation_frequency)

#%% 1D scan with ATS: S21 vs load time scan, Pulse scheme
'''
23 dB attenuation:
4Vpp <--> 612.85mV (89mK)
3Vpp <--> 474mV (65mK)?
2Vpp <--> 316mV (45mK)?
1Vpp <--> 156mV  (25mK)?

0.5Vpp <--> 77mV
0.25Vpp <--> 38.7mV
0.2Vpp <--> 31.1mV
0.15Vpp <--> 23.2mV
0.1Vpp <--> 15.65mV
0.05Vpp <--> 8mV
'''
from imp import reload
reload(qtt.scans)
acquisition_controller.update_acquisitionkwargs(
                 samples_per_record=1024,
                 records_per_buffer=1000,
                 buffers_per_acquisition=100)

RF.power.set(-55)
awg1.ch1_amp(4)
awg1.ch2_amp(4)

#LP=-196.7
#RP=71.3
#gates.LP(LP)
#gates.Vsd(RP*10)    # 4 to ground, 2 to gate, Do not exceed +-160mV

scanjob = {'sweepdata': {'param':'tload', 'start':1e-9, 'end':100e-9, 'step':10e-9,'wait_time':0.001},
           'minstrument':['acquisition_controller'],'t_measure':2000e-9,'data_points':1000,'t_init':2000e-9,'wait_time_startscan':3,}
dataset=qtt.scans.pulsescheme1D(station, scanjob, datafunction=acquisition_controller.acquisition, plotparam='S21mag')
#ph=MatPlot(dataset.S21phase)

awg1.stop_all()
awg2.stop_all()


#%% 1D scan with ATS: S21 vs load time scan, Time trace not on zero detuning
detuning =100
endtime=100e-6
steptime=2e-6
timesteps=np.arange(1e-6,endtime,steptime)
#generate_pulsescheme_timetrace2(t_load,detuning,2000e-6)
#awg1.clock_freq(.1e9)
#time.sleep(5)


#generate_pulsescheme_RP2(300e-6,10e-6,1e-6,20e-6,150)
#from imp import reload
#
#generate_pulsescheme_timetrace_S_T(400e-6,timesteps,5e-6,500e-9,-100)#t_total,timesteps,t_singlet,t_delay,det

awg1.stop()

    
from imp import reload
reload(qtt.scans)
acquisition_controller_hist.update_acquisitionkwargs(
                 samples_per_record=1024*4,
                 records_per_buffer=50,
                 buffers_per_acquisition=500)

#change_resfreq()
awg1.clock_freq(1e9)
numberacq=2

RF.power.set(-40)

#LP=215
RP=121.9
#gates.LP(LP)
gates.Vsd(RP*10)    # 4 to ground, 2 to gate, Do not exceed +-160mV

scanjob = {'sweepdata': {'param':'tload', 'start':1e-6, 'end':endtime, 'step':steptime,'wait_time':0.001},
           'minstrument':['acquisition_controller'],'t_measure':2000e-9,'data_points':1000,'t_init':2000e-9,'wait_time_startscan':3,'numberacq':numberacq}
dataset=qtt.scans.pulsescheme1D_timetrace2(station, scanjob, datafunction=acquisition_controller_hist.acquisition, plotparam='S21mag')
ph=MatPlot(dataset.S21mag)
#plot_hist(15)

#p = fit_T1_2(dataset,1)   #(dataset,number of first points to exclude)
#plot_fit_T1_2(p,detuning)

#awg1.ch1_state(0)
#awg1.ch2_state(0)
awg1.stop()


#%% 1D scan with ATS: S21 vs plunger voltage scan, selective loading
from imp import reload
reload(qtt.scans)

#generate_pulsescheme_loading_4stage_vertical(t_total,t_unload,t_load,t_det,t_comp,t_delay,unloadpos,loadpos,span,points,det)
#time.sleep(10)
mvspan = 100
step = mvspan/50

acquisition_controller_hist.update_acquisitionkwargs(
                 samples_per_record=1024*4,
                 records_per_buffer=50,
                 buffers_per_acquisition=500)

numberacq=1

RF.power.set(-40)

awg1.ch1_state(1)
awg1.ch2_state(1)

#LP=-351
#RP=-57
#gates.RP(RP)
#gates.LP(LP)

scanjob = {'sweepdata': {'param':'plungergate', 'start':-mvspan/2, 'end':mvspan/2, 'step':step,'wait_time':0.001},
           'minstrument':['acquisition_controller'],'t_measure':2000e-9,'data_points':1000,'t_init':2000e-9,'wait_time_startscan':3,'numberacq':numberacq}
dataset=qtt.scans.pulsescheme1D_selectiveloading(station, scanjob, datafunction=acquisition_controller_hist.acquisition, plotparam='S21mag')
ph=MatPlot(dataset.S21mag)
#plot_hist(15)


awg1.stop_all()
awg2.stop_all()

    
#%% Plot old datasets

#dataset_old = qcodes.load_data('2018-02-26/14-02-04_qtt_pulsescheme1D')
dataset_old = qcodes.load_data('K:/ns/qt/spin-qubits/data/QClab_Vandersypen3/SQ19-89-1-7-10/2019-09-26/10-50-16_qtt_RFscan1D')
dataset=dataset_old
#plot_hist(readtime,44)
ph = MatPlot(dataset_old.S21phase)
ph = MatPlot(dataset_old.S21mag)
#ph_old=QtPlot(dataset_old.default_parameter_array('S21phase'), show_window=True)

#%% tests
'''
acquisition_controller_fast.cut_length=100000
acquisition_controller_fast.cut_length
ats_inst.sample_rate()

awg.sweep_gate('RP', 0.1, 0.001)


acquisition_controller.acquisition()

acquisition_controller_fast.acquisition()
first_column_items = 
[row[0] for row in acquisition_controller_fast.acquisition()]
'''
#pulse_values = {}
#pulse_values['chan1']= [0,-150,00]
#pulse_values['chan2'] = [0,-200,300]
#waittimes = [3000e-9,1000e-9,1e-6]
#awg.pulse_gates(pulse_values,waittimes)
#gate_voltages=pulse_values

#offset = 0
#for ix, x in enumerate(waittimes):
#    offset = offset + (x*pulse_values['chan1'][ix])
#offset = offset/(np.sum(waittimes))
#print(offset)

#awg.make_pulses(gate_voltages['chan1'],waittimes,[100,-100])
#awg.make_pulses(gate_voltages['chan2'],waittimes)

#samples = [int(x * 1e9) for x in waittimes]
#print(samples)
#print(np.sum(samples))

#pulse_values=[[0,1], [1,1],[1,0]]
#waittimes = [100e-9,100e-9,100e-9]
#wave=awg.make_sawtooth_pulses(pulse_values,waittimes)
#len(wave)


def generate_pulseschem_sawtooth(t_total,t_det,t_slope,triggerdelay,det):
    pulse_values = {}
    marker1 = {}
    marker2= {}
    t_wait=t_total-t_det-(2*t_slope)
    pulse_values['chan1']= [[0,0], [0,det],[det,det],[det,0]]
    pulse_values['chan2']= [[0,0], [0,-det],[-det,-det],[-det,0]]
    waittimes = [t_wait,t_slope,t_det,t_slope] #Timelength of the three regimes
    
    marker1['chan1'] = [0,1,0] # Set the markers with value 1
    marker2['chan1'] = [1,0,0]
    marker1['chan2'] = [0,1,0] # Set the markers with value 1
    marker2['chan2'] = [1,0,0]
    markerwaittimes = [triggerdelay,2e-6,(t_total-triggerdelay-2e-6)]
    awg.pulse_gates_sawtooth(pulse_values,waittimes,marker1,marker2,markerwaittimes) # Sent to AWG
    

def generate_pulsescheme_RP(t_load,t_total,amp):
    pulse_values = {}
    marker1 = {}
    marker2= {}
    t_wait = t_total - 100e-6-t_load # waiting time spent in (0,2) Regime
    pulse_values['chan1']= [0, -100,-amp] # Amplitudes of RP in the three regimes (measurement,init,mixing)
    pulse_values['chan2']= [0,100,amp] # Amplitudes of LP in the three regimes (measurement,init,mixing)
    
    waittimes = [100e-6,t_wait,t_load] #Timelength of the three regimes
    
    marker1['chan1'] = [1,0,0] # Set the markers with value 1
    marker2['chan1'] = [1,0,0]
    marker1['chan2'] = [1,0,0]
    marker2['chan2'] = [1,0,0]
    markerwaittimes = waittimes
    awg.pulse_gates(pulse_values,waittimes,marker1,marker2,markerwaittimes) # Sent to AWG
    
def generate_pulsescheme_RP_hist(t_wait,amp):
    pulse_values = {}
    marker1 = {}
    marker2= {}
    pulse_values['chan1']= [0,amp]
    pulse_values['chan2']= [0,amp]
    t_wait1 = t_wait-2.5e-6
    waittimes = [2.5e-6,t_wait1]
    
    marker1['chan1'] = [1,0]
    marker2['chan1'] = [1,0]
    marker1['chan2'] = [1,0]
    marker2['chan2'] = [1,0]
    markerwaittimes = waittimes
    awg.pulse_gates(pulse_values,waittimes,marker1,marker2,markerwaittimes)   

def generate_pulsescheme_rabi2(t_burst):
    pulse_values = {}
    marker1 = {}
    marker2= {}
    t_wait = 0e-6 - 0.1e-6 - t_burst
    pulse_values['chan3']= [0,1,0,0]
    waittimes = [1e-6,t_burst-1e-6,100e-9,t_wait]
    
    marker1['chan3'] = [0,1,0,0]
    marker2['chan3'] = [1,1,0,0]
    markerwaittimes = waittimes
    awg.pulse_gates(pulse_values,waittimes,marker1,marker2,markerwaittimes)
    
def generate_pulsescheme_RP3(t_total,t_01,t_11,delay,det):
    awg1.clock_freq(1e9)
    pulse_values = {}
    marker1 = {}
    marker2= {}
    t_measure = t_total - t_11-t_01 - delay-2e-6 # Time at the interdot transition
    pulse_values['chan1']= [0,0,0,det,det] # Amplitudes of RP in the three regimes (interdot,(0,1),(1,1))
    pulse_values['chan2']= [0,0,0,-det,-det] # Amplitudes of LP in the three regimes (interdot,(0,1),(1,1))
    
    waittimes = [delay,2e-6,t_measure,t_01,t_11] #Timelength of the three regimes
    
    marker1['chan1'] = [0,0,0,1,0] # Set the markers with value 1
    marker2['chan1'] = [0,1,0,0,0]
    marker1['chan2'] = [0,1,0,0,0]
    marker2['chan2'] = [0,1,0,0,0]
    
    markerwaittimes = waittimes
    awg.pulse_gates(pulse_values,waittimes,marker1,marker2,markerwaittimes) # Sent to AWG
    
def generate_pulsescheme_timetrace2(t_burst,det,t_total):
    pulse_values = {}
    marker1 = {}
    marker2= {}
    pulse_values['chan1']=[]
    pulse_values['chan2']=[]
    marker1['chan1'] = []
    marker2['chan1'] = []
    marker1['chan2'] = []
    marker2['chan2'] = []
    waittimes = []
    for ix, x in enumerate(t_burst):
        x=x*0.1
        pulse_values['chan1'].append(0)
        pulse_values['chan1'].append(0)
        pulse_values['chan1'].append(-150)
        pulse_values['chan1'].append(det)
        pulse_values['chan2'].append(0)
        pulse_values['chan2'].append(0)
        pulse_values['chan2'].append(-300)
        pulse_values['chan2'].append(-det)
        marker1['chan1'].append(1)
        marker1['chan1'].append(0)
        marker1['chan1'].append(0)
        marker1['chan1'].append(0)
        marker2['chan1'].append(1)
        marker2['chan1'].append(0)
        marker2['chan1'].append(0)
        marker2['chan1'].append(0)
        marker1['chan2'].append(1)
        marker1['chan2'].append(0)
        marker1['chan2'].append(0)
        marker1['chan2'].append(0)
        marker2['chan2'].append(0)
        marker2['chan2'].append(1)
        marker2['chan2'].append(0)
        marker2['chan2'].append(0)            
        t_wait = t_total*0.1 - 0.1e-6 - x - 0.1e-6
        waittimes.append(0.1e-6)
        waittimes.append(t_wait)
        waittimes.append(0.1e-6)
        waittimes.append(x)
        
timesteps = [100e-6,150e-6,200e-6]
generate_pulsescheme_timetrace_S_T(400e-6,timesteps,50e-6,500e-9)

def generate_pulsescheme_timetrace_S_T(t_total,timesteps,t_singlet,t_delay,det):#t_total,timesteps,t_singlet,t_delay,det
    pulse_values = {}
    marker1 = {}
    marker2= {}
    pulse_values['chan1']=[]
    pulse_values['chan2']=[]
    marker1['chan1'] = []
    marker2['chan1'] = []
    marker1['chan2'] = []
    marker2['chan2'] = []
    waittimes = []
    markerwaittimes = []
    for ix, x in enumerate(timesteps):
        pulse_values['chan1'].append(0)
        pulse_values['chan1'].append(300)
        pulse_values['chan1'].append(det)
        pulse_values['chan2'].append(0)
        pulse_values['chan2'].append(-300)
        pulse_values['chan2'].append(-det)
        marker1['chan1'].append(0)
        marker1['chan1'].append(1)
        marker1['chan1'].append(0)
        marker2['chan1'].append(0)
        marker2['chan1'].append(1)
        marker2['chan1'].append(0)
        marker1['chan2'].append(0)
        marker1['chan2'].append(1)
        marker1['chan2'].append(0)
        marker2['chan2'].append(0)
        marker2['chan2'].append(1)
        marker2['chan2'].append(0)            
        t_wait = t_total - t_singlet - x
        waittimes.append(t_wait)
        waittimes.append(t_singlet)
        waittimes.append(x)
        markerwaittimes.append(t_delay)
        markerwaittimes.append(2e-6)
        markerwaittimes.append(t_total-2e-6-t_delay)        

    awg.pulse_gates(pulse_values,waittimes,marker1,marker2,markerwaittimes)
#
#generate_pulsescheme_selectload_hor(400e-6,10e-6,10e-6,10e-6,500e-9,-100,-50,20,50,30)
    

    
    

    
#    
#t_load=np.arange(1e-6,100e-6,2e-6)
#generate_pulsescheme_timetrace2(t_load,-15)
#    
#generate_pulsescheme_RP3(100e-6,1e-6,5e-6,0,1000)


#%% overnight scan selective loading

from imp import reload
reload(qtt.scans)

acquisition_controller_hist.update_acquisitionkwargs(
                 samples_per_record=1024*4,
                 records_per_buffer=50,
                 buffers_per_acquisition=500)


#triton.magnet_sweeprate.set(0.05)
#triton.Bz(0.01)
#triton.Bz(-0.05)
#triton.Bz(0.04)
#triton.Bz(-0.03)
#triton.Bz(0.02)
#triton.Bz(-0.01)
#triton.Bz(0)
#triton.magnet_sweeprate.set(0.05)


RP=118.3
gates.Vsd(RP*10)


mvspan = 100
step = mvspan/50
numberacq=3

RF.power.set(-40)


awg1.start()
awg1.ch1_state(1)
awg1.ch2_state(1)

#generate_pulsescheme_selectload_ver(400e-6,.1e-6,.1e-6,.1e-6,500e-9,-400,150,200,50,-30) #(t_total,t_unload,t_load,t_det,t_delay,posx,posy,span,points,det)
awg1.clock_freq(1e9)

scanjob = {'sweepdata': {'param':'plungergate', 'start':0, 'end':mvspan, 'step':step,'wait_time':0.01},
           'stepdata': {'param':'Bz', 'start':0, 'end':2, 'step':0.01, 'wait_time':60},
           'minstrument':['acquisition_controller'],'wait_time_startscan':3,'numberacq':numberacq}
dataset=qtt.scans.Bzscan2D_selectiveloading(station, scanjob, datafunction=acquisition_controller_hist.acquisition, rescal=rescal, plotparam='S21mag')
#    ph1 = QtPlot(dataset.S21mag)
ph2 = MatPlot(dataset.S21mag)
ph3 = MatPlot(dataset.S21phase)

awg1.stop()
awg1.ch1_state(0)
awg1.ch2_state(0)




triton.magnet_sweeprate.set(0.05)
triton.Bz(0.01)
triton.Bz(-0.05)
triton.Bz(0.04)
triton.Bz(-0.03)
triton.Bz(0.02)
triton.Bz(-0.01)
triton.Bz(0)
triton.magnet_sweeprate.set(0.05)

RF.power.set(-40)


awg1.start()
awg1.ch1_state(1)
awg1.ch2_state(1)

#generate_pulsescheme_selectload_ver(400e-6,.1e-6,.1e-6,.1e-6,500e-9,-400,150,200,50,-30) #(t_total,t_unload,t_load,t_det,t_delay,posx,posy,span,points,det)
awg1.clock_freq(1e9)

scanjob = {'sweepdata': {'param':'plungergate', 'start':0, 'end':mvspan, 'step':step,'wait_time':0.01},
           'stepdata': {'param':'Bz', 'start':0, 'end':-2, 'step':0.01, 'wait_time':60},
           'minstrument':['acquisition_controller'],'wait_time_startscan':3,'numberacq':numberacq}
dataset=qtt.scans.Bzscan2D_selectiveloading(station, scanjob, datafunction=acquisition_controller_hist.acquisition, rescal=rescal, plotparam='S21mag')
#    ph1 = QtPlot(dataset.S21mag)
ph2 = MatPlot(dataset.S21mag)
ph3 = MatPlot(dataset.S21phase)

awg1.stop()
awg1.ch1_state(0)
awg1.ch2_state(0)




triton.magnet_sweeprate.set(0.1)
triton.Bz(0.01)
triton.Bz(-0.05)
triton.Bz(0.04)
triton.Bz(-0.03)
triton.Bz(0.02)
triton.Bz(-0.01)
triton.Bz(0)
triton.magnet_sweeprate.set(0.05)

 

# set the frequency back to resonance    
RF.frequency.set(f)
LO.frequency.set(f + acquisition_controller.demodulation_frequency)
